### Name: trDDEInstall
### Title: Install a DDE server (Windows only) for Tinn-R
### Aliases: trDDEInstall
### Keywords: utilities

### ** Examples

  ## Not run: 
##D     ## DDE exchange protocol is available ONLY under Windows!
##D 
##D     ## Also, this cannot be run by examples() but should be OK when pasted
##D     ## into an interactive R session with the tcltk package loaded
##D 
##D     ## Here is how you can test these features under Windows
##D     options(use.DDE = TRUE)
##D     library(TinnR) # This should automatically start the
##D     # DDE server named 'TclEval Tinn-R', according to the option set
##D 
##D     # Get some data in the user workspace
##D     data(trees)
##D     a <- 1
##D     b <- "some text in the first instance of R"
##D 
##D     #######################################################
##D     # To test these functions in an external program, we need now
##D     # to start a second instance of R. In this second instance, enter:
##D     library(tcltk)
##D     .Tcl("package require dde")
##D     .Tcl("dde services TclEval {}")
##D     # You should get 'TclEval Tinn-R' in the list
##D     # if the server in the first instance is running
##D 
##D     # Now, request a calltip for the function 'ls'
##D     # This is done in two steps:
##D     # 1) Execute the command 'trCallTip' with this code chunk as argument
##D     .Tcl("dde execute TclEval Tinn-R {trCallTip {res <- ls(}}")
##D     # 2) Retrieve the calltip from the variable tr_CallTip
##D     .Tcl("dde request TclEval Tinn-R tr_CallTip")
##D 
##D     # Another way to trigger DDE commands (for programs that do not support
##D     # DDE is to use 'execdde.exe' of the tcltk2 package (see ?tk2dde)
##D 
##D     # It is also possible to copy the calltip to a file, or to the clipboard
##D     # by specifying it after the command (also the two additional arguments
##D     # have their default values changed)
##D     .Tcl("dde execute TclEval Tinn-R {trCallTip {library(} clipboard TRUE 40 TRUE}")
##D     # Look at what is in the clipboard
##D     cat(readClipboard(), "\n")
##D 
##D     # The process is similar to get completion lists
##D     .Tcl("dde execute TclEval Tinn-R {trComplete {iris$}}")
##D     .Tcl("dde request TclEval Tinn-R tr_Complete")
##D 
##D     # Get the list of variables in the user workspace of the first R instance
##D     # into the clipboard (use also the other arguments to get the type of objects)
##D     .Tcl("dde execute TclEval Tinn-R {trComplete {} clipboard TRUE { - }}")
##D     # Look at what is in the clipboard
##D     cat(readClipboard(), "\n")
##D   
## End(Not run)



